; modified by rockyone		pour  MI-3 MI-9			19/03/2017	
; Add  SPU							22/03/2017
; modified open spectrum to source+34				01.08.2018
;          --------------------------
;								26.05.2019
;		
;				OPEN SPC SPU
; 
;
; Source buffer 56544    octets pour SPCU_PI1.S ( conversion en gris )
;	+0     	   34    octets pour dcompression palette SPC
;	+34 	54104    octets pour fichiers Spc Spu
;
;	
; Ecran         Adresse physique de l'cran.
; Color	        Couleur no 15. Blanc ($777) le plus frquemment.
; File_size     taille du fichier spectrum
;
; 	Call Spc_SPU ( L Source, L Ecran, Low(file_size) )
;
; Retour : D0 = 0  OK.
;	   D0 =-2  Erreur.
;.........................................................................
;
; Buffer Source: 56544 bytes pour conversion en 16 niveaux de gris Spc_PI1
;                                                        
;	+0   	19104 octets : palette dcompress
;	+19104  32000 octets : image dcompress
;	+51104	 5120 octets : 320*16
;	+56224	  320 octets : line buffer
;
;-------------------------------------------------------------------------
;SPC : 
; 	 +0	W	'SP'
;  	 +2	W	$0
;  	 +4	LW	Taille de l'image compress
;  	 +8	LW	Taille des palettes compress
; 	+12	B	Images comprss : plan par plan
;		         - la premire ligne n'est pas sauvegarde -
;	+?	B	Palettes compres
;
;SPU :  +0              data image   32000
;	+32000	        palette      19104 
;			total	     51104 octets
;-------------------------------------------------------------------------

		movem.l	d1-d7/a0-a6,-(sp)	
		movem.l	60(sp),a0-a1
		move.w	68(sp),d6
		movea.l	a0,a2			; adresse retour palette		

		lea.l	34(a0),a0		; le fichier spectrum doit 	
;						; tre charg ici
		moveq.l	#0,d0
		cmpi.w	#$5350,(a0)		; "SP" ?
		beq.s	spc			

;.......................................SPU............................
		ext.l	d6
		cmpi.w	#51104,d6		; file size ?
		bne	error

		bsr.s	first_line		; Efface premire ligne
;						; de l'cran
		lea.l	160(a0),a0	        ; Passe premiere ligne de 
;						; l'image source

		move.l	#31840/4-1,d1		 
copy_pic:	move.l	(a0)+,(a1)+		; copy to destination
		dbra.w	d1,copy_pic

		move.l	#19104/4-1,d1		 
copy_pal:	move.l	(a0)+,(a2)+	
		dbra.w	d1,copy_pal

		bra	end_prg

;------------------------------------------------------------------------
first_line:	moveq.l	#39,d7		; Efface la 1re ligne cran
clear:		clr.l	(a1)+
		dbra.w	d7,clear
		rts
;-----------------------------------------------SPC----------------------

spc:		lea.l	12(a0),a4		; data image source
		movea.l	a4,a3
		moveq.l	#1,d1			; Saut de plans.
		moveq.l	#7,d2

		bsr.s first_line

		lea.l	31840(a1),a6		; fin cran
		lea.l 	8(a1),a5		; dernier plan

read_code:	move.b	(a4)+,d3		; Dbut du dcompactage.
		ext.w	d3			; Mthode des pack-bits.
		bpl.s	literal

		neg.w	d3
		addq.w	#1,d3
		move.b	(a4)+,d7
	
recopy_code:	move.b	d7,(a1)
		adda.w	d1,a1			; Saut de plan.
		exg.l	d1,d2
		dbra.w	d3,recopy_code

		bra.s	depac_end
	
literal:	move.b	(a4)+,(a1)
		adda.w	d1,a1
		exg.l	d1,d2
		dbra.w	d3,literal
	
depac_end:	cmpa.l	a1,a6			; Fin d'un plan ?
		bhi.s	read_code		; Non => on y retourne.

		lea.l	-31838(a1),a1		; On passe au plan suivant.
		cmp.l	a1,a5			; Dernier plan ?
		bhi.s	read_code		; Non => on y retourne.

;...............................................	
		move.l	a4,d7			; 
		addq.l	#1,d7			; calculer le nombre
		bclr.b	#0,d7			; d'octets dcompacts...
	
		sub.l	a3,d7		
		cmp.l	4(a0),d7		; Taille image compact
		bne.s	error			; Erreur ! => Fin.
;...............................................
;a4 a3 source
;a2 buffer palette
		move.l	8(a0),d1		; Taille palette compact
		adda.l	d7,a3			; On pointe sur la palette
		movea.l	a3,a4			; pour control

		move.w	#$254,d4		; Nb de palettes - 1.
		moveq.l	#0,d7

pal:		moveq.l	#13,d2			; Dpactage de la palette.
		move.w	(a4)+,d3
		lsr.w	#1,d3
		move.w	d7,(a2)+	 	; 1re couleur de chaques
;						; palette.
color:		lsr.w	#1,d3
		bcc.s	empty

		move.w	(a4)+,(a2)+
		dbra.w	d2,color

		bra.s	pal_end
	
empty:		move.w	d7,(a2)+
		dbra.w	d2,color
	
pal_end:	move.w	#$fff,(a2)+		; Dernire couleurs de
		dbra.w	d4,pal			; chaques palettes.

		suba.l	a3,a4			; Nunber byte depacted
		cmpa.l	d1,a4			; Compare avec la taille
;						; de la palette compress
		beq.s	end_prg

;-------------------------------------------------------------------------
error:		moveq.l	#-2,d0
end_prg:	movem.l	(sp)+,d1-d7/a0-a6	
		rts				
;-------------------------------------------------------------------------	

	